EDIT - task #4009
task # 6992 (New): Refactor and modernize REST web service API

consider using jackson as json library
01/30/2014 12:26 PM - Andreas Kohlbecker

Status: New Start date:

Priority: Priority14 Due date:

Assignee: Andreas Mller % Done: 0%
Category: cdmlib-remote Estimated time: 0:00 hour
Target version: Release 5.44

Severity: critical

Description

using jackson instead of json-lib may have an significant impact on the REST service performance:
perfomance of json-lib by comparig two REST service calls:

1. generic service: ab -n 20
'http://127.0.0.1:8080/description/distributionInfoFor/0eb6ca37-3365-4af5-a800-8fc4b8c366fa.json?statusOrderPreference=1&s
ubAreaPreference=1&hideMarkedAreas=70ceb5bc-3413-4b4e-8ef3-de29d06a42a5&part=mapUriParams&part=tree&part=elem
ents'

e 31kb / response

¢ Max time: 1,991s

¢ Min time: 0.766s

e Average: 0,854s

1. portal service: ab -n 20
'http://127.0.0.1:8080/portal/description/distributioninfoFor/0eb6cal37-3365-4af5-a800-8fc4b8c366fa.json ?statusOrderPreferenc
e=1&subAreaPreference=1&hideMarkedAreas=70ceb5bc-3413-4b4e-8ef3-de29d06a42a5&part=mapUriParams&part=tree&part
=elements'

¢ 500kb /response

e Max time: 3,689s

* Min time: 1,133s

¢ Average: 1,325s

It looks like the amount of objects to be serialized is consuming an significant amount of time.
further incidence is given by the following benchmark results:

¢ http://www.cowtowncoder.com/blog/archives/2009/02/entry 213.html

¢ http://www.cowtowncoder.com/perf/json-count-2009-02-20-2cpus/index.html

For further evidence see [#4925#note-7]
additional TODO once this is done perform the measurements taken for #4925

for spring configuration see:
https://docs.spring.io/spring-boot/docs/current/reference/htmli/howto.html#howto.spring-mvc.customize-jackson-objectmapper
Related tickets:

e Duplicate #3440

Subtasks:

feature request # 4644: json lib incorrectly serializes values containig the characters...

New

Related issues:

Related to EDIT - bug #3480: tagged text with square bracket confuses json
Related to EDIT - task #9359: Update cdmlib, taxeditor, cdmserver etc. depend...
Related to EDIT - bug #6179: Use @RestController where appropriate

Related to EDIT - task #10055: Updates, upgrades and cleanup 2023

New
Closed
New
New

Associated revisions

Revision df617ad6 - 06/15/2023 11:26 AM - Katja Luther
ref #4009: add MANIFEST changes to provide jackson library

Revision 11651c04 - 06/15/2023 01:53 PM - Katja Luther
ref #4009: adapt Term Import to jackson

Revision 182591d5 - 06/16/2023 02:00 PM - Katja Luther
ref #4009: continue removing json-lib from Taxeditor - adapt

cdmServerinfo

Revision ec145531 - 06/16/2023 02:01 PM - Katja Luther

ref #4009: remove json-lib from pom and Manifest

Revision 190b0534 - 06/16/2023 02:01 PM - Katja Luther

ref #4009: remove json-lib from build.properties

History

#1 - 05/01/2015 01:47 AM - Andreas Miiller

- Target version deleted ()

#2 - 05/06/2015 12:09 PM - Andreas Miuller

- Target version set to cdmlib-remote cleanup

#3 - 06/03/2015 01:52 PM - Andreas Kohlbecker

- Target version changed from cdmlib-remote cleanup to cdmlib - Next Major Release

- Priority changed from Priority08 to Priority14

- Severity changed from normal to major

increasing severity and priority as this issue has shown to be last big culprit for bad performance in #4925

#4 - 06/08/2015 10:49 AM - Andreas Kohlbecker

- Target version deleted (cdmlib - Next Major Release)

#5 - 06/10/2015 03:46 PM - Andreas Miiller
- Target version set to Release 3.8

- Priority changed from Priority14 to Highest

#6 - 06/10/2015 03:46 PM - Andreas Miuller

- Severity changed from major to critical

#7 - 07/21/2015 02:24 PM - Andreas Kohlbecker

- Target version changed from Release 3.8 to cdmlib-remote cleanup

#8 - 09/14/2017 09:44 AM - Andreas Kohlbecker
- Description updated

- Private changed from Yes to No

#9 - 09/14/2017 09:44 AM - Andreas Kohlbecker

- Related to bug #3480: tagged text with square bracket confuses json added

#10 - 09/28/2017 08:33 AM - Andreas Kohlbecker
- Parent task set to #6992

#11 - 02/04/2021 09:23 PM - Andreas Miiller

- Related to task #9359: Update cdmlib, taxeditor, cdmserver etc. dependencies added

#12 - 03/23/2022 11:28 AM - Andreas Miiller
- Assignee changed from Andreas Kohlbecker to Andreas Mliller

- Target version changed from cdmlib-remote cleanup to Release 5.44

#13 - 03/23/2022 12:18 PM - Andreas Miiller
- Related to bug #6179: Use @RestController where appropriate added

#14 - 12/27/2022 03:34 PM - Andreas Miiller
- Related to task #10055: Updates, upgrades and cleanup 2023 added

#19 - 05/27/2023 08:40 PM - Andreas Miiller

- Description updated

#20 - 05/27/2023 08:40 PM - Andreas Miiller

- Description updated

#21 - 06/16/2023 02:19 PM - Katja Luther

The taxeditor is json-lib free now.
